\ Forth debugger for BForth

.( Loading Debugger ... )

INTERNAL

18 constant debtab

0 value nestdepth
0 value (break)xt
2variable debspot
2variable backspot

: setspot ( ad -- )
    dup @ over debspot 2!
    (break)xt swap ! ;

: ?nestable ( xt -- [xt'] flag )
    begin
      dup @ [ ' bye @ ] literal = if >body @ false else
      dup ['] execute = if drop dup          false else
      dup ['] perform = if drop dup @        false else
        true
      then then then
    until
    dup @ [ ' setspot @ ] literal = if true exit then
    dup @ [ ' emit @ ] literal = if cell+ @ body> true else
    drop false then ;

: nextad ( -- ad )
    debspot 2@ cell+ >r
    dup ['] lit = if drop r> cell+ else
    dup ['] branch = (: over ['] | = or | _else _repeat _again :)
                  if drop r> @ else
    dup ['] ?branch = (: over ['] | = or | _if _until _while :)
                  if drop dup if r> cell+ else r> @ then else
    dup ['] (s") = (: over ['] | = or | (c") (z") (.") (abort") :)
                  if drop r> count + 1+ aligned else
    dup ['] unnest = if drop r>drop 0 else
    dup ['] _?do = if drop 2dup = if r> @ else r> cell+ then else
    dup ['] _loop = if drop rp@ 3 cells+ @ dup 1+ xor 0x80000000 and
                      if r> cell+ else r> @ then else
    dup ['] _+loop = if drop rp@ 3 cells+ @ dup 2 pick + xor 0x80000000 and
                      if r> cell+ else r> @ then else
    drop r>
    then then then then then then then then ;

: (backer)
    debspot 2@ !
    backspot 2@
    2dup  dup @ swap debspot 2!
    to (break)xt  !
    r> cell- >r ;

: (break) ( -- )
    debspot 2@ !
    cr
    base @ >r hex
    debspot 2@ 6 u.r space
    r> base !
    nestdepth 0max 0 ?do ." | " loop
    dup .name
    >name c@  nestdepth 2* +  debtab swap -
    dup 0> if spaces else drop then
    .s  0
    begin
      begin drop
        s" hrqn a" key
        scan nip dup
      until
      dup 6 =
    while
      cr ." <spc> - Single Step, n - Nest, q - Quit, r - Run, a - Again, h - Help"
    repeat
    case
      5 of r> cell- >r exit endof
      4 of quit endof
      3 of debspot 2@ drop
             ?nestable
             if >body
               1 +to nestdepth
             else nextad
             then endof
      2 of nextad endof
      1 of (break)xt  debspot 2@ nip  backspot 2!
           ['] (backer) to (break)xt
           nextad endof
    endcase ( ad ) ?dup
    if setspot
    else nestdepth
      if r> r> dup setspot >r >r then
      -1 +to nestdepth
    then
    r> cell- >r ;

' (break) to (break)xt

EXTERNAL

: dbg
    '
    begin dup @ [ ' bye @ ] literal =
    while >body @
    repeat
    dup @ [ ' setspot @ ] literal <> abort" Cannot debug"
    >body  setspot
    0 to nestdepth ;

: debug
    >in @
    dbg
    >in ! ;

MODULE

.( OK) cr